// SimpleNet.h

#pragma once

#include "SimpleATL.h"

using namespace System;
using namespace System::Runtime::InteropServices;

namespace SimpleNet
{
	public __gc class Class1
	{
	public:
		Class1() {_pSimpleATL = new CSimpleATL();}
		~Class1() {delete _pSimpleATL;}

	public:
        void get_ThreadID (/*[out, retval]*/ Int32* pVal) {

			long res;
			HRESULT hRes = _pSimpleATL->get_ThreadID(&res);
			
			if(FAILED(hRes)) {
				Marshal::ThrowExceptionForHR(hRes);
			}
			else {
				IntPtr ptrInt((void*)&res);
				*pVal = Marshal::ReadInt32(ptrInt);
			}
		}
		void SetManagerName (/*[in]*/ String* bstrName) {

			IntPtr ptrBstr = Marshal::StringToBSTR(bstrName);

			HRESULT hRes = _pSimpleATL->SetManagerName((BSTR)ptrBstr.ToPointer());
			if(FAILED(hRes)) {
				Marshal::ThrowExceptionForHR(hRes);
			}
		}
		void GetManagerName(/*[out, retval]*/ String** pbstrName) {

			BSTR pbstrTemp;
			HRESULT hRes = _pSimpleATL->GetManagerName(&pbstrTemp);
			if(FAILED(hRes)) {
				Marshal::ThrowExceptionForHR(hRes);
			}
			else {
				(*pbstrName) = Marshal::PtrToStringBSTR(pbstrTemp);
				Marshal::FreeBSTR(pbstrTemp);
			}
		}
		
	private:
		CSimpleATL*		_pSimpleATL;
	};
}
